// Configuratia pe coloana curenta - Backtracking
#include <fstream>
#include <vector>
#include <iomanip>
#include <cmath>
#include <iostream>
#include <cstring>
using namespace std;

#define DIM1 14
#define DIM2 1 << 14
#define INF 16000 //0x3f3f3f3f
typedef  short int US;

ifstream fin("cmin.in");
ofstream fout("cmin.out");

US x[DIM1][DIM1];
US y[DIM1][DIM1];
US a[DIM1][DIM1];
int col[DIM1];
US c[DIM2][DIM1][DIM1*DIM1 / 2];
int n; // dim matricei (n trebuie sa fie par)
int N; // nr total de jetoane

int deasupra;

void Read();
// costul minim sa pun de la col j incolo, daca pusesem pana la j -i "pus" jetoane
// si pe coloana j am jetoane in mask
US Cmin(int k, int mask, int j, int pus);  // k - poz in sirul x[],
void Init();

int main()
{
	Read();
	memset(c, -1, sizeof(c));
	fout <<  Cmin(1, 0, 1, 0) << '\n';
	fout.close();
	return 0;
}

US Cmin(int k, int mask, int j, int pus)
{
	US& ret = c[mask][j][pus];
	if ( ret == -1 )
		ret = INF;
	if ( ret != INF )       // Vital !
			return ret;
	if ( j == n + 1 )
	{
		if ( N % 2 == 0 )
		{
			if ( pus == N / 2  )
				return ret = 0;
		}
		else
			if ( pus == N / 2 || pus == N / 2 + 1)
				return ret = 0;
		return ret = INF;
	}

	if ( pus > N / 2 + 1 )
		return ret = INF;

	if ( pus == N / 2 && col[j] > n / 2  + 1)
		return ret = INF;

	if ( k > col[j] ) // combinari
	{
		US cost = 0;
		deasupra = 0;
		for ( int i = 1; i <= col[j]; ++i )
		{
			cost += abs(double(x[i][j] - y[i][j]));
			if ( x[i][j] <= n / 2 )
				deasupra++;
		}

		if ( deasupra + pus  > N / 2 + 1  )
			return ret = INF;

		ret = min(ret, US(cost + Cmin(1, 0, j + 1, pus +  deasupra)));
		return ret;
	}

	for ( US c, i = x[k-1][j] + 1; i <= n - col[j] + k; ++i )
	{
		x[k][j] = i;
		mask |= (1 << (i-1));    // seteaza bit
		c = Cmin(k + 1, mask, j, pus);
		mask  &= ~(1 << (i-1));  // sterge bit
		ret = min(ret, c);
	}
	return ret;
}

void Read()
{
	fin >> n;
	for ( int i = 1; i <= n; ++i )
		for ( int j = 1; j <= n; ++j )
		{
			fin >> a[i][j];
			col[j] += a[i][j];
			N += a[i][j];
		}

	for (int j = 1; j <= n; ++j )
	{
		int k = 0;
		for ( int i = 1; i <= n; ++i )
			if ( a[i][j] )
				y[++k][j] = i;
	}
	fin.close();
}
