/* prof. Eugen Nodea -  Solutie 100p
    combinari C(N + k, N+1) - cu invers modular
*/
# include <cstdio>
# include <cstring>
# define M 666013

int N, i, k;

void GCD (long long A, long long B, long long &X, long long &Y)
{
    long long X0, Y0;
    if (B ==0 )
    {
        X = 1;
        Y = 0;
        return;
    }

    GCD (B, A%B, X0, Y0);
    X = Y0;
    Y = X0 - Y0 * (A/B);
}

long long inversm(int N)
{
    long long X, Y;

    GCD (N, M, X, Y);
    if (X<=0)
    {
        X = M + X%M;
    }
    return X;
}

long long comb(int N, int k)
{
    long long A, B, C, i;
	A = B = (long long) 1;
	for(i=k+1; i<=N ; i++)
        A = (A*i) % M;

	for(i=1; i<= N - k; i++)
        B = (B*i) % M;

    A = (A * inversm(B)) % M;
	return (int) A;
}

int main()
{
	freopen("implementare.in","r",stdin);
	freopen("implementare.out","w",stdout);

	scanf("%d %d",&N, &k);

    printf("%d\n",comb( N + k , k +1));

	return 0;
}
