//Marius Nicoli O(N^2)
#include <stdio.h>
#define MOD 666013
#define DIM 1010

int C[DIM][DIM];
int T[DIM][DIM];
int S[DIM*DIM];
int R, H, i, j, k, t, verzi, toate;
long long sum, aux;
int main() {
	
	FILE *f = fopen("cladire.in","r");
	FILE *g = fopen("cladire.out","w");
	fscanf(f,"%d %d",&R, &H);
	C[1][0] = C[1][1] = 1;
	for (i=2;i<=H;i++) {
		C[i][0] = C[i][i] = 1;
		for (j=1;j<i;j++) {
			C[i][j] = C[i-1][j] + C[i-1][j-1];
			if (C[i][j] >= MOD)
				C[i][j] -= MOD;
		}
	}
	
	for (i=0;i<=H;i++) {
		if ((i+H) % 2 != 0) {
			T[H][i] = 0;
		} else {
			verzi = (H-i)/2;
			toate = verzi + i;
			T[H][i] = C[toate][verzi];
		}
	}
	
	for (i=0;i<=R;i++)
		for (j=0;j<=R;j++) {
			aux = (T[H][i] * (long long)T[H][j]);
			aux %= MOD;
			
			S[i+j] += aux;
			if (S[i+j] >= MOD)
				S[i+j] -= MOD;
		}
	
	for (i=0;i<=R;i++) {
		j = R-i;
		aux = S[i]*(long long)S[j];
		aux %= MOD;
		sum += aux;
		if (sum >= MOD)
			sum -= MOD;
	}
	
	fprintf(g,"%lld\n",sum);
	return 0;
}
